/* rvores AVL (com chaves inteiras) */ 

#define TRUE 1
#define FALSE 0
#define Bool int




typedef int TreeEntry;

typedef enum balancefactor { LH , EH , RH } BalanceFactor;

typedef struct treenode {
  BalanceFactor bf;
  TreeEntry entry;
  struct treenode *left;
  struct treenode *right;
} TreeNode;


typedef TreeNode *Tree;


// cria uma rvore vazia
Tree CreateTree(void);

// testa se a rvore  vazia 
int TreeEmpty(Tree);

// conta o nmero de nodos da rvore
int TreeSize(Tree);

// calcula a altura da rvore
int TreeHeight(Tree);

// apaga toda rvore
void ClearTree(Tree *);

typedef void (*Fun)(TreeNode *);

// travessias
void Preorder(Tree, Fun);
void Inorder(Tree, Fun);
void Postorder(Tree, Fun);

// apaga toda rvore (usando a travessia Postorder)
void ClearTreePost(Tree *); 


//==============================================
// RVORES BINRIAS DE PROCURA Balanceadas (AVL)

// procura um elemento numa rvore binria de procura (RECURSIVA)
TreeNode *TreeSearch(Tree, TreeEntry);

// insere um novo elemento numa rvore binria de procura AVL.
Tree InsertTree(Tree, TreeEntry);

// insere um novo elemento numa rvore  AVL 
// (o terceiro parametro (Bool*) indica se a a altura da rvore aumentou ou no)
Tree InsertAVL(Tree, TreeEntry, Bool *);

// balanceamneto da rvore na situao RIGHT-RIGHT-TALLER
Tree RightBalance(Tree);

// balanceamneto da rvore na situao LEFT-LEFT-TALLER
Tree LeftBalance(Tree);

// rotao para a direita
Tree RotateRight(Tree);

// rotao para a esquerda
Tree RotateLeft(Tree);



